package TCC_FABIO;

import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import java.awt.Image;
import java.awt.image.BufferedImage;

import mmtext.MMTextBinarize;
import mmtext.images.*;
import mmtext.images.gui.WindowHistogram;
import mmtext.images.gui.WindowImages;
import mmtext.images.operators.Histogram;
import mmtext.images.utils.ImageBuilder;

public class Chen {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {		
		BufferedImage img = null;
				
		try {
		    img = ImageIO.read(new File("/home/fabio/testegray.jpg"));
		} catch (IOException e) {
		}
		
		IRGBImage imgRGB = new RGBImage(img);
		int[][] RMatrix = new int[imgRGB.getHeight()][imgRGB.getWidth()];
		int[][] GMatrix = new int[imgRGB.getHeight()][imgRGB.getWidth()];
		int[][] BMatrix = new int[imgRGB.getHeight()][imgRGB.getWidth()];
		
		
		for (int x = 0; x < imgRGB.getHeight(); x++){
			for (int y = 0; y < imgRGB.getWidth(); y++){
				RMatrix[x][y] = imgRGB.getPixel(y, x, 0);
				GMatrix[x][y] = imgRGB.getPixel(y, x, 1);
				BMatrix[x][y] = imgRGB.getPixel(y, x, 2);

/*				RMatrix[x][y] = roundedPixel(imgRGB.getPixel(y, x, 0));
				GMatrix[x][y] = roundedPixel(imgRGB.getPixel(y, x, 1));
				BMatrix[x][y] = roundedPixel(imgRGB.getPixel(y, x, 2));*/
			}				
		}
		
	/*	WindowImages.show(new GrayScaleImage(RMatrix));
		WindowImages.show(new GrayScaleImage(GMatrix));
		WindowImages.show(new GrayScaleImage(BMatrix));*/
		
		Histogram RHistogram = new Histogram(new GrayScaleImage(RMatrix));
		Histogram GHistogram = new Histogram(new GrayScaleImage(GMatrix));
		Histogram BHistogram = new Histogram(new GrayScaleImage(BMatrix));
		
		WindowHistogram.show(new GrayScaleImage(RMatrix));
		WindowHistogram.show(new GrayScaleImage(GMatrix));
		WindowHistogram.show(new GrayScaleImage(BMatrix));
		calculateI(imgRGB);
		
		int THRESHOLD = 2;
		
		int RMaxPeak = RHistogram.getMaxPeakPixel();
		int GMaxPeak = GHistogram.getMaxPeakPixel();
		int BMaxPeak = BHistogram.getMaxPeakPixel();
		
		int MaxPeak = Math.max(RMaxPeak, GMaxPeak);
		MaxPeak = Math.max(MaxPeak, BMaxPeak);
		
		int[][] RMatrixNew = RMatrix;
		int[][] GMatrixNew = GMatrix;
		int[][] BMatrixNew = BMatrix;
		
		
		System.out.println(MaxPeak);
		
		for (int x = 0; x < imgRGB.getHeight(); x++){
			for (int y = 0; y < imgRGB.getWidth(); y++){
				if (RMatrix[x][y] >= RMaxPeak - THRESHOLD){
					RMatrixNew[x][y] = 0;
					/*GMatrixNew[x][y] = 255;
					BMatrixNew[x][y] = 255;*/
				}
				if (GMatrix[x][y] >= GMaxPeak - THRESHOLD){
					RMatrixNew[x][y] = 0;
					/*GMatrixNew[x][y] = 255;
					BMatrixNew[x][y] = 255;*/
				}
				if (BMatrix[x][y] >= BMaxPeak - THRESHOLD){
					RMatrixNew[x][y] = 0;
					/*GMatrixNew[x][y] = 255;
					BMatrixNew[x][y] = 255;*/
				}					
				/*RMatrix[x][y] = imgRGB.getPixel(y, x, 0);
				GMatrix[x][y] = imgRGB.getPixel(y, x, 1);
				BMatrix[x][y] = imgRGB.getPixel(y, x, 2);*/
			}				
		}
		GrayScaleImage RGrayImage = new GrayScaleImage(RMatrix);
		GrayScaleImage GGrayImage = new GrayScaleImage(GMatrix);
		GrayScaleImage BGrayImage = new GrayScaleImage(BMatrix);
		
		/*WindowImages.show(new GrayScaleImage(RMatrixNew));
		WindowImages.show(new GrayScaleImage(GMatrixNew));
		WindowImages.show(new GrayScaleImage(BMatrixNew));*/
				
		/*WindowHistogram.show(RGrayImage);
		WindowHistogram.show(GGrayImage);
		WindowHistogram.show(BGrayImage);
		calculateI(imgRGB);*/
		
		int MatrixImg[][][] = new int[3][][];
		MatrixImg[0] = RMatrixNew;
		MatrixImg[1] = GMatrixNew;
		MatrixImg[2] = BMatrixNew;		
		
		RGBImage RGBBackRemove = new RGBImage(RGrayImage.getWidth(),RGrayImage.getWidth());
		
		RGBBackRemove.setPixels(MatrixImg);
		
		/*Histogram RHistogram = new Histogram(RGrayImage);
		Histogram GHistogram = new Histogram(GGrayImage);
		Histogram BHistogram = new Histogram(BGrayImage);
		
		RHistogram.getHistogramAccumulator();
		GHistogram.getHistogramAccumulator();
		BHistogram.getHistogramAccumulator();
		*/
//		Image imagem = new Image(img); 
		
		
		//IRGBImage imgRGB = new RGBImage(ImageBuilder.convertToArray(ImageIO.read(new File("/Users/wonderalexandre/Desktop/9.png"))));
		
//		IGrayScaleImage img = new GrayScaleImage(ImageBuilder.convertToArray(ImageIO.read(new File("/Users/wonderalexandre/Desktop/9.png"))));
		
		//IBinaryImage img2 = new BinaryImage(ImageBuilder.convertToArray(ImageIO.read(new File("/Users/wonderalexandre/Desktop/9.png"))));

		//metodo de binarizacao
		//IBinaryImage imgSaida = MMTextBinarize.getBinary(img, img.getHeight(), 2);
		
		WindowImages.show(RGBBackRemove);
		//WindowImages.show(imgRGB);
	}
	
	public static int roundedPixel(int pixel){
		if (pixel <= 10) return 10;
		else if (pixel <= 20) return 20;
		else if (pixel <= 30) return 30;
		else if (pixel <= 40) return 40;
		else if (pixel <= 50) return 50;
		else if (pixel <= 60) return 60;
		else if (pixel <= 70) return 70;
		else if (pixel <= 80) return 80;
		else if (pixel <= 90) return 90;
		else if (pixel <= 100) return 100;
		else if (pixel <= 110) return 110;
		else if (pixel <= 120) return 120;
		else if (pixel <= 130) return 130;
		else if (pixel <= 140) return 140;
		else if (pixel <= 150) return 150;
		else if (pixel <= 160) return 160;
		else if (pixel <= 170) return 170;
		else if (pixel <= 180) return 180;
		else if (pixel <= 190) return 190;
		else if (pixel <= 200) return 200;
		else if (pixel <= 210) return 210;
		else if (pixel <= 220) return 220;
		else if (pixel <= 230) return 230;
		else if (pixel <= 240) return 240;		
		else return 255; 
	}

	public static void xProjection(BufferedImage img){
		IGrayScaleImage img = new GrayScaleImage(ImageBuilder.convertToArray(img));
		
		GrayScaleImage imgGray = new GrayScaleImage(img);
				
	}
		
	
	
	public static void calculateI(IRGBImage imgRGB){
		
		int IImagem[][] = new int[imgRGB.getWidth()][imgRGB.getHeight()];
		double SImagem[][] = new double[imgRGB.getWidth()][imgRGB.getHeight()];
		int HImagem[][] = new int[imgRGB.getWidth()][imgRGB.getHeight()];
		
		/* calcula I */
		
		for(int w=0; w < imgRGB.getWidth(); w++){
            for(int h=0; h < imgRGB.getHeight(); h++){
            	IImagem[w][h] += (imgRGB.getPixel(w, h, 0) + imgRGB.getPixel(w, h, 1) + imgRGB.getPixel(w, h, 2))/3;
            	int min = Math.min(Math.min(imgRGB.getPixel(w, h, 0), imgRGB.getPixel(w, h, 1)), imgRGB.getPixel(w, h, 2));
            	SImagem[w][h] = 1.0 - (double) min/ (double) IImagem[w][h]; 
            }
        }
		
		
		
		WindowHistogram.show(new GrayScaleImage(IImagem));
	}

}

