package TCC_FABIO;

import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import java.awt.Image;
import java.awt.image.BufferedImage;

import mmtext.MMTextBinarize;
import mmtext.images.*;
import mmtext.images.gui.WindowHistogram;
import mmtext.images.gui.WindowImages;
import mmtext.images.operators.Histogram;
import mmtext.images.utils.ImageBuilder;


public class Projecao {
	
	

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		IGrayScaleImage img = new GrayScaleImage(ImageBuilder.convertToArray(ImageIO.read(new File("/home/fabio/aaa.jpg"))));
		int yProj[] = new int[img.getWidth()];
		
		for (int x = 0; x < img.getHeight(); x++){
			for (int y = 0; y < img.getWidth(); y++){
				yProj[y] += img.getPixel(y, x);
			}
		}
		
		for (int i = 0; i < yProj.length; i++){
			yProj[i] = (int) Math.floor((double) yProj[i]/(double) img.getWidth());			
		}
		printProjection(yProj, img);
		WindowImages.show(img);
	}
	
	public static void printProjection(int proj[], IGrayScaleImage img) {
		IGrayScaleImage hist = new GrayScaleImage(img.getWidth(), img.getHeight());
		
		for (int x = 0; x < img.getHeight(); x++){
			for (int y = 0; y < img.getWidth(); y++){
				if (y <= proj[x]) hist.setPixel(y, x, 0);
				else hist.setPixel(y, x, 255);
			}
			
		}
		
		WindowImages.show(hist);
			
	}

	public void drawHistogram(IGrayScaleImage img){
	    final int WIN_WIDTH = 300;
	    final int WIN_HEIGHT = 210;
	    final int HIST_WIDTH = 256;
	    final int HIST_HEIGHT = 128;
	    final int BAR_HEIGHT = 12;
	    final int XMARGIN = 20;
	    final int YMARGIN = 10;
	    IRGBImage imgOut;
		
    	imgOut = new RGBImage(WIN_WIDTH, WIN_HEIGHT);
        imgOut.initImage(255);
        Histogram histogram = new Histogram(img);
        int h[] = histogram.getHistogram(); 
        
        int maxCount = 0;

        for (int i = 0; i<h.length; i++){
            if (h[i] > maxCount) {
                maxCount = h[i];
            }
        }
        
        drawPlot(maxCount, h);
        int x = XMARGIN + 1;
        int y = YMARGIN + HIST_HEIGHT + 2;
        drawUnscaledColorBar(x-1, y, 256, BAR_HEIGHT);
        y += BAR_HEIGHT+2;
        drawText(histogram, x, y);
    }

	
}
