package mmtext;



import mmtext.images.BinaryImage;
import mmtext.images.FloatImage;
import mmtext.images.GrayScaleImage;
import mmtext.images.IBinaryImage;
import mmtext.images.IFloatImage;
import mmtext.images.IGrayScaleImage;
import mmtext.images.gui.WindowImages;
import mmtext.images.operators.MorphologicalOperator;
import mmtext.images.operators.ThresholdGlobal;
import mmtext.images.utils.ImageUtils;

public class HDILocalMaxMin {

	
	
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		MMTextBinarize.main(args);

	}
	
	public static IBinaryImage getBinary(IGrayScaleImage img){

		IBinaryImage se = MorphologicalOperator.createImageDecorator(255, 0, 3,3);
        IGrayScaleImage imgDilate = MorphologicalOperator.dilation(img, se);
        IGrayScaleImage imgErode = MorphologicalOperator.erosion(img, se);
        
        IGrayScaleImage D = new GrayScaleImage(img.getWidth(), img.getHeight());
        float level;
        float max = img.getPixelMax();
        for(int x=0; x < img.getWidth(); x++){
        	for(int y=0; y < img.getHeight(); y++){
        		level = (float) (((imgDilate.getPixel(x, y) - imgErode.getPixel(x, y)) / (imgDilate.getPixel(x, y) + imgErode.getPixel(x, y) + 0.0000001)) * max);
        		D.setPixel(x, y,(int) level);
        	}
        }
        
        IBinaryImage E = new ThresholdGlobal(D).otsu();
        /*
        WindowHistogram winHist = new WindowHistogram();
        winHist.drawHistogram(D);
        winHist.drawLineVerticle(new ThresholdGlobal(D).getIndexOtsu());
        WindowImages.show(winHist.getGraphics());
        */
        //WindowImages.show(E);
        
        
        se = MorphologicalOperator.createImageDecorator(255, 0, 7,7);
        
        IFloatImage Emean = getMean(img, E, se);
        IFloatImage Estd = getStandardDeviation(img, E, Emean, se);
        
        IBinaryImage R = new BinaryImage(img.getWidth(), img.getHeight());
        int nMin = se.getArea()/12;
        
        for(int w=0; w < img.getWidth(); w++){
        	for(int h=0; h < img.getHeight(); h++){
        		int ne = 0;
        		for(int x=-se.getWidth()/2, xx=0; xx < se.getWidth(); x++, xx++){ //Varendo o elemento estruturante
                    for(int y=-se.getHeight()/2, yy=0; yy < se.getHeight(); y++, yy++){
                        if(ImageUtils.isIndexInImage(img, w + xx, h + yy) && !se.isPixelBackground(xx, yy)){ 
                        	  if(!E.isPixelBackground(xx + w, yy + h)){
                        		  ne++;
                        	  }
                       }
                    }
        		}
        		
        		if(ne >= nMin && img.getPixel(w, h) <= Emean.getPixel(w, h) + Estd.getPixel(w, h)/2){
        			R.setPixel(w, h, 0);
        		}else{
        			R.setPixel(w, h, 255);
        		}
        	}
        }
        R = MorphologicalOperator.areaOpen(R, 20);
        
        WindowImages.show(R);
        return R;
        
	}
	
	public static IFloatImage getStandardDeviation(IGrayScaleImage img, IBinaryImage E, IFloatImage Emean, IBinaryImage se){
		IFloatImage means = new FloatImage(img.getWidth(), img.getHeight());
		
        for(int w=0; w < img.getWidth(); w++){
            for(int h=0; h < img.getHeight(); h++){
            	float value=0;
            	int n = 0;
            	for(int x=-se.getWidth()/2, xx=0; xx < se.getWidth(); x++, xx++){ //Varendo o elemento estruturante
                    for(int y=-se.getHeight()/2, yy=0; yy < se.getHeight(); y++, yy++){
                        if(ImageUtils.isIndexInImage(img, w + xx, h + yy) && !se.isPixelBackground(xx, yy)){ 
                        	  if(!E.isPixelBackground(xx + w, yy + h)){
                        		  value += Math.pow((img.getPixel(xx + w, yy + h) - Emean.getPixel(xx + w, yy + h)), 2);
                        		  n++;
                        	  }
                       }
                    }
                }
            	means.setPixel(w, h, (int) Math.sqrt(value / n));
                   
            }
        }
		
		return means;
	}
	
	public static IFloatImage getMean(IGrayScaleImage img, IBinaryImage E, IBinaryImage se){
		IFloatImage sd = new FloatImage(img.getWidth(), img.getHeight());
	     
        for(int w=0; w < img.getWidth(); w++){
            for(int h=0; h < img.getHeight(); h++){
            	float value=0;
            	int n=0;
            	for(int x=-se.getWidth()/2, xx=0; xx < se.getWidth(); x++, xx++){ //Varendo o elemento estruturante
                    for(int y=-se.getHeight()/2, yy=0; yy < se.getHeight(); y++, yy++){
                        if(ImageUtils.isIndexInImage(img, w + xx, h + yy) && !se.isPixelBackground(xx, yy)){ 
                        	if(!E.isPixelBackground(xx + w, yy + h)){
                        		value += img.getPixel(xx + w, yy + h);
                        		n++;
                           }
                       }
                    }
                }
            	if(n != 0)
            		sd.setPixel(w, h, value / n);
                   
            }
        }
		
		return sd;
	}

}
