package mmtext.images;



public interface IBinaryImage extends IImage{
    
	public void setId(int id);
	
	public int getId();
	
    public void initImage(int color);
    
    public IBinaryImage duplicate();
    
    public int getPixel(int x, int y);
    
    public int getPixelBinary(int x, int y);
    
    public void setPixel(int x, int y, int value);
    
    public int[][] getPixels();
    
    public void setPixels(int matrix[][]);
    
    public int getBackground();
    
    public void setBackground(int background);
    
    public int getForeground();
    
    public IBinaryImage invert();
    
    public IGrayScaleImage convertGrayScale();
    
    public int getArea();
    
    public void setMatrix(int matrix[][]);
    
    public int[] getHistogramXprojection();
    
    public int[] getHistogramYprojection();
    
    public void setPixel(int i, int level); 
    
    public int getPixel(int i);
    
    public boolean isPixelBackground(int i);
    
    public boolean isPixelBackground(int x, int y);
    
    public int getOriginX();
    
    public int getOriginY();
    
    public void setOrigin(int x, int y);
    
    public IBinaryImage reflection(IBinaryImage img);
    
    public BoundBox getBoundBox(int x1, int y1, int x2, int y2);
}
    